#include "handmade.h"

void debug_printf(wchar_t* format, ...) { 
    int bufsize = wcslen(format)*10;
    wchar_t *output = (wchar_t*)malloc(bufsize);
    va_list list;
    va_start(list, format);
    vswprintf(output, bufsize, format, list);
    OutputDebugStringW(output);
    free(output);
}

internal void renderWeirdGradient(GameOffscreenBuffer *buffer, int xOffset, int yOffset) {
    int bytesPerPixel = 4;
    int pitch = buffer->width*bytesPerPixel;
    uint8 *row = (uint8 *)buffer->memory;
    for (int y = 0; y < buffer->height; y++) {
        uint32 *pixel = (uint32*)row;
        for (int x = 0; x < buffer->width; x++) {
            uint8 blue = x + xOffset;
            uint8 green = y + yOffset;
            *pixel++ = (green << 8) | blue;
        }
        row += pitch;
    }
}

internal void gameUpdateAndRender(GameOffscreenBuffer *buffer, GameInput *input) {
    renderWeirdGradient(buffer, input->xOffset, input->yOffset);
}
